-------------------------------------------------------------------------------
--|> Config
-- Configure settings and options
-------------------------------------------------------------------------------
--> LuaCheck Settings
-- luacheck: no max line length
-- luacheck: ignore  _.* for k self
--> weizPVP Globals
-- luacheck: globals weizPVP weizPVP.Settings ViragDevTool ViragDevTool_AddData
--> Addon Libs Globals
-- luacheck: globals LibStub AceConfig LSM
--> WoW Globals
-- luacheck: globals InCombatLockdown
-------------------------------------------------------------------------------
--|> LIBS
-------------------------------------------------------------------------------
local AceConfig = LibStub("AceConfig-3.0")

-------------------------------------------------------------------------------
--|> GLOBALS
-------------------------------------------------------------------------------
weizPVP.Options = {}


--=> Slash Commands Option Table
-------------------------------------------------------------------------------
weizPVP.SlashCommands = {
	name = "Slash Commands",
	order = -3,
	type = "group",
	args = {
		intro = {
			name = "weizPVP Slash Commands",
			type = "description",
			order = 1,
			cmdHidden = true,
		},
		show = {
			name = "Show",
			desc = "Show the weizPVP window.",
			type = 'execute',
			order = 2,
			func = function()
				if not InCombatLockdown() then
				weizPVP.HeaderFrame:Show()
				weizPVP.CoreFrame:Show()
				end
			end,
			dialogHidden = true
		},
		hide = {
			name = "Hide",
			desc = "Hide the weizPVP window.",
			type = 'execute',
			order = 2,
			func = function()
				if not InCombatLockdown() then
					weizPVP.HeaderFrame:Hide()
					weizPVP.CoreFrame:Hide()
					end
			end,
			dialogHidden = true
		},
		crosshair = {
			name = "Crosshair",
			desc = "Toggles the Crosshair feature.",
			type = 'execute',
			order = 2,
			func = function()
				weizPVP:ToggleCrosshair()
			end,
			dialogHidden = true
		},
	},
}


--=> Register Slash Commands
-------------------------------------------------------------------------------
AceConfig:RegisterOptionsTable("weizPVP", weizPVP.SlashCommands, {"wpvp","weizpvp"})
