-------------------------------------------------------------------------------
--|> StatusBar
-- Manages the messages in the StatusBar frame
-------------------------------------------------------------------------------
--> LuaCheck Settings
-- luacheck: no max line length
-- luacheck: ignore  _.* for k self
--> weizPVP Globals
-- luacheck: globals weizPVP weizPVP.Settings
--> Addon Libs Globals
-- luacheck: globals LibStub ViragDevTool_AddData
--> WoW Globals
-- luacheck: globals CreateFrame UIParent RAID_CLASS_COLORS InCombatLockdown
-------------------------------------------------------------------------------
--|> FUNCTIONS
-------------------------------------------------------------------------------

--=> weizPVP.FooterFrame: SETTINGS
-----------------------------------------------------------------------

--=> AnimationGroup: Fade Highlight
weizPVP.FooterFrame.Text.anim = weizPVP.FooterFrame.Text:CreateAnimationGroup()
weizPVP.FooterFrame.Text.anim:SetScript(
    "OnFinished",
    function()
        -- weizPVP.FooterFrame.Text:SetAlpha(0)
    end
)

local fadeIn = weizPVP.FooterFrame.Text.anim:CreateAnimation("Alpha")
fadeIn:SetDuration(0.2)
fadeIn:SetFromAlpha(0)
fadeIn:SetToAlpha(1)
fadeIn:SetEndDelay(3) --> Set the number of seconds the animation delays after finishing.
fadeIn:SetOrder(1)

local fadeOut = weizPVP.FooterFrame.Text.anim:CreateAnimation("Alpha")
fadeOut:SetDuration(2)
fadeOut:SetFromAlpha(1)
fadeOut:SetToAlpha(0)
fadeOut:SetOrder(2)

--=> Set Status Bar Message
function weizPVP:SetStatusBarMessage(stringSB, fadeEN, duration)
    weizPVP.FooterFrame.Text:SetText(stringSB)
    if fadeEN then
        fadeIn:SetEndDelay(duration)
        fadeOut:SetToAlpha(0)
        weizPVP.FooterFrame.Text.anim:SetScript("OnFinished",function()
        weizPVP.FooterFrame.Text:SetAlpha(0)
        end)
    else
        fadeOut:SetToAlpha(1)
        weizPVP.FooterFrame.Text.anim:SetScript("OnFinished",function()
        weizPVP.FooterFrame.Text:SetAlpha(1)
        end)
    end
    weizPVP.FooterFrame.Text.anim:Play()
end
