-------------------------------------------------------------------------------
--|> weizPVP
-------------------------------------------------------------------------------
--> LuaCheck Settings
-- luacheck: no max line length
-- luacheck: ignore  _.* for k self
--> DEBUG GLOBALS
-- luacheck: globals ViragDevTool_AddData
--> weizPVP Globals
-- luacheck: globals weizPVP
--> Libs
-- luacheck: globals LibStub
--> WoW Globals
-- luacheck: globals table.wipe GetRealmName GetUnitName UnitLevel UnitFactionGroup GetCVar GetNetStats MAX_PLAYER_LEVEL_TABLE
-- luacheck: globals GetExpansionLevel
-------------------------------------------------------------------------------
--|> LIBS
-------------------------------------------------------------------------------
weizPVP = LibStub("AceAddon-3.0"):NewAddon("weizPVP", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local SM = LibStub:GetLibrary("LibSharedMedia-3.0")

-------------------------------------------------------------------------------
--|> GLOBALS
-------------------------------------------------------------------------------
--> Settings
weizPVP.Settings = {} --> Create blank global table for weizPVP Settings
--> Player Tables
weizPVP.PlayerDB = {} --> player db of detected players
weizPVP.PlayerActiveCache = {} --> Cache of players while active

--> Player Counts
weizPVP.NearbyCount = 0
weizPVP.ListCount = 0
weizPVP.ListVisableCount = 0



-------------------------------------------------------------------------------
--=> Default Settings
-------------------------------------------------------------------------------
weizPVP.Settings = {
    Enabled = true,
    Shown = true,
    --> Resource Usage
    ResourceUsage = {
        High = false,
        MaxShownPlayers = 28
    },
    --> BG/BORDER FOR ALL FRAMES
    BACKGROUNDTEXTURE = "weizPVP-Background",
    BORDERTEXTURE = "weizPVP-Border",
    BACKGROUNDCOLOR = {
        R = 0,
        G = 0,
        B = 0,
        A = 0.7
    },
    --> MAIN FRAME
    MAIN = {
        WIDTH = 260,
        HEIGHT = 0,
        BORDER_SIZE = 2
    },
    --> SCROLL FRAME
    SCROLL = {
        HEIGHT = 0,
        WIDTH = 0,
        scrollBarWidth = 4,
        SCROLLOFFET = 0
    },
    --> LIST FRAME
    LIST = {
        ROWHEIGHT = 0,
        HEIGHT = 0,
        WIDTH = 0
    },
    --> Header Settings
    HEADER = {
        HEIGHT = 34,
        WIDTH = 0,
        TEXT = {
            FONT = "Roboto Condensed BoldItalic",
            FONTSIZE = 20,
            FONTOUTLINE = "OUTLINE"
        },
        BUTTONS = {
            CONFIG = true,
            STATS = true,
            CLEAR = true,
            PREV = true,
            NEXT = true,
            CLOSE = true
        }
    },
    --> FOOTER FRAME
    FOOTER = {
        HEIGHT = 22,
        TEXT = {
            -- FONT = "Accidental Presidency",
            FONT = "Roboto Condensed Bold",
            FONTSIZE = 16,
            FONTOUTLINE = "OUTLINE"
        }
    },
    --> BARS
    BARS = {
        ALPHA_DEFAULT = 1,
        ALPHA_INACTIVE = 0.5,
        ALPHA_DEAD = 0.5,
        MAXNUMBER = 24,
        HEIGHT = 18,
        WIDTH = 0,
        SPACING = 1,
        NUM_DISPLAYED = 12,
        TEXTURE = "weizPVP.Bar",
        HIGHLIGHTTEXTURE = "weizPVP.Bar-Highlight",
        BGTEXTURE = "weizPVP.BarBackground",
        NAME_FONT_DIFF = -2,
        NAME_ALPHA_STEALTH = 0.6,
        LEVEL_FONT_DIFF = -2,
        GUILD_FONT_DIFF = -4
    },
    --> FONTS
    FONTS = {
        NARROW = "Accidental Presidency",
        NARROWITALIC = "Accidental Presidency Italic",
        NORMAL = "Roboto Condensed Bold",
        BOLD = "Roboto Condensed Bold",
        ITALIC = "Accidental Presidency Italic",
        BOLDITALIC = "Roboto Condensed BoldItalic"
    }
}

--=> Computed Settings
-------------------------------------------------------------------------------
weizPVP.Settings.LIST.ROWHEIGHT = weizPVP.Settings.BARS.HEIGHT + weizPVP.Settings.BARS.SPACING
weizPVP.Settings.SCROLL.HEIGHT =
    (weizPVP.Settings.LIST.ROWHEIGHT * weizPVP.Settings.BARS.NUM_DISPLAYED) + weizPVP.Settings.BARS.SPACING
weizPVP.Settings.SCROLL.WIDTH = weizPVP.Settings.MAIN.WIDTH
weizPVP.Settings.MAIN.HEIGHT = weizPVP.Settings.SCROLL.HEIGHT
weizPVP.Settings.LIST.HEIGHT = weizPVP.Settings.LIST.ROWHEIGHT * weizPVP.Settings.BARS.MAXNUMBER
weizPVP.Settings.LIST.WIDTH = weizPVP.Settings.SCROLL.WIDTH
weizPVP.Settings.BARS.WIDTH = weizPVP.Settings.LIST.WIDTH
weizPVP.Settings.HEADER.WIDTH = weizPVP.Settings.MAIN.WIDTH

-------------------------------------------------------------------------------
--=> SHARED MEDIA ASSETS
-------------------------------------------------------------------------------
--> Status Bars
SM:Register("statusbar", "weizPVP.Bar", [[Interface\Addons\weizPVP\Textures\bar.tga]])
SM:Register("statusbar", "weizPVP.Bar-Highlight", [[Interface\Addons\weizPVP\Textures\bar-highlight.tga]])
--> Bakgrounds
SM:Register("background", "weizPVP-Background", [[Interface\Addons\weizPVP\Textures\bg.tga]])
SM:Register("background", "weizPVP.BarBackground", [[Interface\Addons\weizPVP\Textures\bar_bg.tga]])
--> Borders
SM:Register("border", "weizPVP-Border", [[Interface\Addons\weizPVP\Textures\border.tga]])
--> Fonts
SM:Register("font", "Roboto Condensed Bold", [[Interface\Addons\weizPVP\Fonts\RobotoCondensed-Bold.ttf]])
SM:Register("font", "Roboto Condensed BoldItalic", [[Interface\Addons\weizPVP\Fonts\RobotoCondensed-BoldItalic.ttf]])
SM:Register("font", "Pepsi", [[Interface\Addons\weizPVP\Fonts\Pepsi.ttf]])
SM:Register("font", "Accidental Presidency", [[Interface\Addons\weizPVP\Fonts\Accidental-Presidency.ttf]])
SM:Register("font", "Accidental Presidency Italic", [[Interface\Addons\weizPVP\Fonts\Accidental-Presidency-Italic.ttf]])
SM:Register("font", "Open Sans Condensed", [[Interface\Addons\weizPVP\Fonts\OpenSansCondensed.ttf]])
SM:Register("font", "Open Sans Condensed Bold", [[Interface\Addons\weizPVP\Fonts\OpenSans-CondBold.ttf]])
SM:Register("font", "Ubuntu Condensed", [[Interface\Addons\weizPVP\Fonts\Ubuntu-C.ttf]])
SM:Register("font", "YanoneKaffeesatz Regular", [[Interface\Addons\weizPVP\Fonts\YanoneKaffeesatz-Regular.ttf]])
SM:Register("font", "Big Noodle Titling", [[Interface\Addons\weizPVP\Fonts\big_noodle_titling.ttf]])
SM:Register("font", "Source Sans Pro SemiBold", [[Interface\Addons\weizPVP\Fonts\SourceSansPro-SemiBold.ttf]])
SM:Register("font", "Source Sans Pro Bold", [[Interface\Addons\weizPVP\Fonts\SourceSansPro-Bold.ttf]])
SM:Register("font", "Source Sans Pro BoldItalic", [[Interface\Addons\weizPVP\Fonts\SourceSansPro-BoldItalic.ttf]])

--> Sounds
--> Sound Alarms
SM:Register("sound", "alarm-1", [[Interface\Addons\weizPVP\Sounds\alarm-1.ogg]])
SM:Register("sound", "alarm-2", [[Interface\Addons\weizPVP\Sounds\alarm-2.ogg]])
--> Sound Alerts
SM:Register("sound", "alert-1", [[Interface\Addons\weizPVP\Sounds\alert-1.ogg]])
SM:Register("sound", "alert-2", [[Interface\Addons\weizPVP\Sounds\alert-2.ogg]])
SM:Register("sound", "alert-3", [[Interface\Addons\weizPVP\Sounds\alert-3.ogg]])
SM:Register("sound", "alert-4", [[Interface\Addons\weizPVP\Sounds\alert-4.ogg]])
SM:Register("sound", "alert-5", [[Interface\Addons\weizPVP\Sounds\alert-5.ogg]])
SM:Register("sound", "alert-6", [[Interface\Addons\weizPVP\Sounds\alert-6.ogg]])
SM:Register("sound", "alert-7", [[Interface\Addons\weizPVP\Sounds\alert-7.ogg]])
SM:Register("sound", "alert-8", [[Interface\Addons\weizPVP\Sounds\alert-8.ogg]])
SM:Register("sound", "alert-9", [[Interface\Addons\weizPVP\Sounds\alert-9.ogg]])
--> Sound Alarms
SM:Register("sound", "beep-1", [[Interface\Addons\weizPVP\Sounds\beep-1.ogg]])
SM:Register("sound", "beep-2", [[Interface\Addons\weizPVP\Sounds\beep-2.ogg]])
--> Sound Interface
SM:Register("sound", "interface-add", [[Interface\Addons\weizPVP\Sounds\interface-add.ogg]])
SM:Register("sound", "interface-remove", [[Interface\Addons\weizPVP\Sounds\binterface-remove.ogg]])
--> Sound Lockon
SM:Register("sound", "lockon-1", [[Interface\Addons\weizPVP\Sounds\lockon-1.ogg]])
--> Sound Music
SM:Register("sound", "music-lmfoa", [[Interface\Addons\weizPVP\Sounds\music-lmfoa.ogg]])
SM:Register("sound", "music-pistolero", [[Interface\Addons\weizPVP\Sounds\music-pistolero.ogg]])
--> Sound Notice
SM:Register("sound", "notice-1", [[Interface\Addons\weizPVP\Sounds\notice-1.ogg]])
SM:Register("sound", "notice-2", [[Interface\Addons\weizPVP\Sounds\notice-2.ogg]])
SM:Register("sound", "notice-3", [[Interface\Addons\weizPVP\Sounds\notice-3.ogg]])
--> Sound Positive
SM:Register("sound", "positive-1", [[Interface\Addons\weizPVP\Sounds\positive-1.ogg]])
--> Sound Voices
SM:Register("sound", "voice-aggro", [[Interface\Addons\weizPVP\Sounds\voice-aggro.ogg]])

-------------------------------------------------------------------------------
--=> Check DBs
-------------------------------------------------------------------------------
function weizPVP:CheckDatabase()
    --> Check for Player DB
    if weizPVP.db.profile.PlayerDB == nil then
        weizPVP.db.profile.PlayerDB = weizPVP.PlayerDB
    else
        weizPVP.PlayerDB = weizPVP.db.profile.PlayerDB
    end

    --> Check for Settings
    if weizPVP.db.profile.Settings == nil then
        weizPVP.db.profile.Settings = weizPVP.Settings
    else
        weizPVP.Settings = weizPVP.db.profile.Settings
    end
end

--=> OnInitialize
-------------------------------------------------------------------------------
function weizPVP:OnInitialize()
    --> LOAD ACE3 DB
    weizPVP.db = LibStub("AceDB-3.0"):New("weizPVP_DB")

    --> Check Database
    weizPVP:CheckDatabase()

    --> Init Static Data Tables
    weizPVP:CreateAbilityDB()
    weizPVP:CreateSpecDB()

    --> Apply stored and set default options
    -- weizPVP.SetupOptions()

    --> Set Player Info
    weizPVP.PlayerLevel = UnitLevel("player") --> player's level
    weizPVP.CurrentRealm = GetRealmName() --> player's realm name
    weizPVP.CurrentCharName = GetUnitName("player") --> player's char name
    weizPVP.FactionName = select(1, UnitFactionGroup("player")) --> Horde/Alliance
    weizPVP.MaxPlayerLevel = MAX_PLAYER_LEVEL_TABLE[GetExpansionLevel()]

end

--=> OnLoad
-------------------------------------------------------------------------------
function weizPVP:OnLoad()
end

--=> OnEnable
-------------------------------------------------------------------------------
function weizPVP:OnEnable()
    --> Timers
    weizPVP:ScheduleRepeatingTimer("ManageExpirations", 1) --> Manages the list expirations on the player list
    weizPVP:ScheduleRepeatingTimer("SaveAddonData", 10) --> Saves data every 10 seconds
    -- weizPVP:ScheduleRepeatingTimer("HighUsageCheck", 5) --> Check for high usage to reduce strain on gathering info

    --=> Registered Events
    -------------------------------------------------------------------------------
    --> DATA COLLECTION
    weizPVP:RegisterEvent("NAME_PLATE_UNIT_ADDED", "NameplateAdded")
    weizPVP:RegisterEvent("NAME_PLATE_UNIT_REMOVED", "NameplateRemoved")
    weizPVP:RegisterEvent("UNIT_FACTION", "ZoneChangedEvent")
    weizPVP:RegisterEvent("PLAYER_TARGET_CHANGED", "PlayerTargetEvent")
    weizPVP:RegisterEvent("UNIT_TARGET", "UnitTargetEvent")
    weizPVP:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent")
    weizPVP:RegisterEvent("PLAYER_DEAD", "PlayerDeadEvent")
    weizPVP:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE", "ChannelNoticeEvent")
    weizPVP:RegisterEvent("UPDATE_MOUSEOVER_UNIT", "PlayerMouseoverEvent")
    weizPVP:RegisterEvent("PLAYER_FOCUS_CHANGED", "PlayerFocusEvent")
    weizPVP:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED", "SpellCastSucceeded")
    --> ZONE REALTED
    weizPVP:RegisterEvent("ZONE_CHANGED", "ZoneChangedEvent")
    weizPVP:RegisterEvent("ZONE_CHANGED_INDOORS", "ZoneChangedEvent")
    weizPVP:RegisterEvent("ZONE_CHANGED_NEW_AREA", "ZoneChangedNewAreaEvent")
    weizPVP:RegisterEvent("PLAYER_ENTERING_WORLD", "PlayerEnteringWorldEvent")
    --> HEALTH UPDATES
    -- weizPVP:RegisterEvent("UNIT_HEALTH_FREQUENT", "UnitHealth") --> Faster updates, but more cpu consuming
    weizPVP:RegisterEvent("UNIT_HEALTH", "UnitHealth")
    --> COMBAT
    weizPVP:RegisterEvent("PLAYER_REGEN_DISABLED", "EnteringCombat")
    weizPVP:RegisterEvent("PLAYER_REGEN_ENABLED", "LeavingCombat")
    --> OTHER
    weizPVP:RegisterEvent("PLAYER_LEVEL_UP", "PlayerLevelUp")
end

--=> OnDisable
-------------------------------------------------------------------------------
function weizPVP:OnDisable()
    --=> UnRegistered Events
    -------------------------------------------------------------------------------
    --> DATA COLLECTION
    weizPVP:UnregisterEvent("NAME_PLATE_UNIT_ADDED", "NameplateAdded")
    weizPVP:UnregisterEvent("NAME_PLATE_UNIT_REMOVED", "NameplateRemoved")
    weizPVP:UnregisterEvent("UNIT_FACTION", "ZoneChangedEvent")
    weizPVP:UnregisterEvent("PLAYER_TARGET_CHANGED", "PlayerTargetEvent")
    weizPVP:UnregisterEvent("UNIT_TARGET", "UnitTargetEvent")
    weizPVP:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent")
    weizPVP:UnregisterEvent("PLAYER_DEAD", "PlayerDeadEvent")
    weizPVP:UnregisterEvent("CHAT_MSG_CHANNEL_NOTICE", "ChannelNoticeEvent")
    weizPVP:UnregisterEvent("UPDATE_MOUSEOVER_UNIT", "PlayerMouseoverEvent")
    weizPVP:UnregisterEvent("PLAYER_FOCUS_CHANGED", "PlayerFocusEvent")
    weizPVP:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED", "SpellCastSucceeded")
    --> ZONE REALTED
    weizPVP:UnregisterEvent("ZONE_CHANGED", "ZoneChangedEvent")
    weizPVP:UnregisterEvent("ZONE_CHANGED_INDOORS", "ZoneChangedEvent")
    weizPVP:UnregisterEvent("ZONE_CHANGED_NEW_AREA", "ZoneChangedNewAreaEvent")
    weizPVP:UnregisterEvent("PLAYER_ENTERING_WORLD", "PlayerEnteringWorldEvent")
    --> HEALTH UPDATES
    -- weizPVP:RegisterEvent("UNIT_HEALTH_FREQUENT", "UnitHealth") --> Faster updates, but more cpu consuming
    weizPVP:UnregisterEvent("UNIT_HEALTH", "UnitHealth")
    --> COMBAT
    weizPVP:UnregisterEvent("PLAYER_REGEN_DISABLED", "EnteringCombat")
    weizPVP:UnregisterEvent("PLAYER_REGEN_ENABLED", "LeavingCombat")
    --> OTHER
    weizPVP:UnregisterEvent("PLAYER_LEVEL_UP", "PlayerLevelUp")
end

--=> Clear List Data
-------------------------------------------------------------------------------
function weizPVP:ClearListData()
    table.wipe(weizPVP.PlayerActiveCache)
    table.wipe(weizPVP.ActiveList)
    table.wipe(weizPVP.InactiveList)
    table.wipe(weizPVP.NearbyList)
    table.wipe(weizPVP.CurrentList)
    weizPVP:RefreshCurrentList()
    weizPVP:UpdateNearbyCount()
end

--=> Save Addon Data
-------------------------------------------------------------------------------
function weizPVP:SaveAddonData()
    weizPVP.db.profile.Settings = weizPVP.Settings
    weizPVP.db.profile.PlayerDB = weizPVP.PlayerDB
end
